KNetwork::KHttpProxySocketDevice Class Reference

`#include <khttproxysocketdevice.h>`

Inheritance diagram for KNetwork::KHttpProxySocketDevice:

## Public Member Functions

| KHttpProxySocketDevice (const KSocketBase *=0L)
| KHttpProxySocketDevice (const KResolverEntry &proxy)
virtual | ~KHttpProxySocketDevice ()
virtual int | capabilities () const
const KResolverEntry & | proxyServer () const
void | setProxyServer (const KResolverEntry &proxy)
virtual void | close ()
virtual bool | connect (const KResolverEntry &address)
virtual bool | connect (const QString &name, const QString &service)
virtual KSocketAddress | peerAddress () const
virtual KSocketAddress | externalAddress () const
Public Member Functions inherited from KNetwork::KSocketDevice
| KSocketDevice (const KSocketBase *=0L)
| KSocketDevice (int fd)
virtual | ~KSocketDevice ()
int | socket () const
virtual bool | setSocketOptions (int opts)
virtual bool | open (int mode)
virtual void | flush ()
virtual bool | create (int family, int type, int protocol)
bool | create (const KResolverEntry &address)
virtual bool | bind (const KResolverEntry &address)
virtual bool | listen (int backlog=5)
virtual KSocketDevice * | accept ()
virtual bool | disconnect ()
virtual Q_LONG | bytesAvailable () const
virtual Q_LONG | waitForMore (int msecs, bool *timeout=0L)
virtual Q_LONG | readBlock (char *data, Q_ULONG maxlen)
virtual Q_LONG | readBlock (char *data, Q_ULONG maxlen, KSocketAddress &from)
virtual Q_LONG | peekBlock (char *data, Q_ULONG maxlen)
virtual Q_LONG | peekBlock (char *data, Q_ULONG maxlen, KSocketAddress &from)
virtual Q_LONG | writeBlock (const char *data, Q_ULONG len)
virtual Q_LONG | writeBlock (const char *data, Q_ULONG len, const KSocketAddress &to)
virtual KSocketAddress | localAddress () const
QSocketNotifier * | readNotifier () const
QSocketNotifier * | writeNotifier () const
QSocketNotifier * | exceptionNotifier () const
virtual bool | poll (bool *input, bool *output, bool *exception=0L, int timeout=-1, bool *timedout=0L)
bool | poll (int timeout=-1, bool *timedout=0L)
Public Member Functions inherited from KNetwork::KActiveSocketBase
| KActiveSocketBase ()
virtual | ~KActiveSocketBase ()
virtual Offset | size () const
virtual Offset | at () const
virtual bool | at (Offset)
virtual bool | atEnd () const
virtual int | getch ()
virtual int | putch (int ch)
virtual int | ungetch (int)
Public Member Functions inherited from KNetwork::KSocketBase
| KSocketBase ()
virtual | ~KSocketBase ()
virtual bool | setBlocking (bool enable)
bool | blocking () const
virtual bool | setAddressReuseable (bool enable)
bool | addressReuseable () const
virtual bool | setIPv6Only (bool enable)
bool | isIPv6Only () const
virtual bool | setBroadcast (bool enable)
bool | broadcast () const
KSocketDevice * | socketDevice () const
virtual void | setSocketDevice (KSocketDevice *device)
int | setRequestedCapabilities (int add, int remove=0)
SocketError | error () const
QString | errorString () const
QMutex * | mutex () const
Public Member Functions inherited from KNetwork::KPassiveSocketBase
| KPassiveSocketBase ()
virtual | ~KPassiveSocketBase ()

## Static Public Attributes

static KResolverEntry | defaultProxy

## Additional Inherited Members

Public Types inherited from KNetwork::KSocketDevice
enum | Capabilities { CanConnectString = 0x01, CanBindString = 0x02, CanNotBind = 0x04, CanNotListen = 0x08, CanMulticast = 0x10, CanNotUseDatagrams = 0x20 }
Public Types inherited from KNetwork::KSocketBase
enum | SocketOptions { Blocking = 0x01, AddressReuseable = 0x02, IPv6Only = 0x04, Keepalive = 0x08, Broadcast = 0x10 }
enum | SocketError { NoError = 0, LookupFailure, AddressInUse, AlreadyCreated, AlreadyBound, AlreadyConnected, NotConnected, NotBound, NotCreated, WouldBlock, ConnectionRefused, ConnectionTimedOut, InProgress, NetFailure, NotSupported, Timeout, UnknownError, RemotelyDisconnected }
Static Public Member Functions inherited from KNetwork::KSocketDevice
static KSocketDevice * | createDefault (KSocketBase *parent)
static KSocketDevice * | createDefault (KSocketBase *parent, int capabilities)
static KSocketDeviceFactoryBase * | setDefaultImpl (KSocketDeviceFactoryBase *factory)
static void | addNewImpl (KSocketDeviceFactoryBase *factory, int capabilities)
Static Public Member Functions inherited from KNetwork::KSocketBase
static QString | errorString (SocketError code)
static bool | isFatalError (int code)
Protected Member Functions inherited from KNetwork::KSocketDevice
| KSocketDevice (bool, const KSocketBase *parent=0L)
virtual QSocketNotifier * | createNotifier (QSocketNotifier::Type type) const
Protected Member Functions inherited from KNetwork::KActiveSocketBase
void | setError (int status, SocketError error)
void | resetError ()
Protected Member Functions inherited from KNetwork::KSocketBase
virtual int | socketOptions () const
bool | hasDevice () const
void | setError (SocketError error)
Protected Attributes inherited from KNetwork::KSocketDevice
int | m_sockfd

## Detailed Description

The low-level backend for HTTP proxying.

This class derives from KSocketDevice and implements the necessary calls to make a connection through an HTTP proxy.

Author
  Thiago Macieira thiag.nosp@m.o.ma.nosp@m.cieir.nosp@m.a@kd.nosp@m.email.nosp@m..net

Definition at line 43 of file khttpproxysocketdevice.h.

## Constructor & Destructor Documentation

KHttpProxySocketDevice::KHttpProxySocketDevice | ( | const KSocketBase * | parent = `0L` | ) |

Constructor.

Definition at line 55 of file khttpproxysocketdevice.cpp.

KHttpProxySocketDevice::KHttpProxySocketDevice | ( | const KResolverEntry & | proxy | ) |

Constructor with proxy server's address.

Definition at line 60 of file khttpproxysocketdevice.cpp.

KHttpProxySocketDevice::~KHttpProxySocketDevice | ( |  | ) |

virtual

Destructor.

Definition at line 66 of file khttpproxysocketdevice.cpp.

## Member Function Documentation

int KHttpProxySocketDevice::capabilities | ( |  | ) | const

virtual

Sets our capabilities.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 74 of file khttpproxysocketdevice.cpp.

void KHttpProxySocketDevice::close | ( |  | ) |

virtual

Closes the socket.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 90 of file khttpproxysocketdevice.cpp.

bool KHttpProxySocketDevice::connect | ( | const KResolverEntry & | address | ) |

virtual

Overrides connection.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 109 of file khttpproxysocketdevice.cpp.

bool KHttpProxySocketDevice::connect | ( | const QString & | name,
|  | const QString & | service
| ) |  |

virtual

Name-based connection.

We can tell the HTTP proxy server the full name.

Definition at line 131 of file khttpproxysocketdevice.cpp.

KSocketAddress KHttpProxySocketDevice::externalAddress | ( |  | ) | const

virtual

Return the externally visible address.

We can't tell what that address is, so this function always returns an empty object.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 104 of file khttpproxysocketdevice.cpp.

KSocketAddress KHttpProxySocketDevice::peerAddress | ( |  | ) | const

virtual

Return the peer address.

Reimplemented from KNetwork::KSocketDevice.

Definition at line 97 of file khttpproxysocketdevice.cpp.

const KResolverEntry & KHttpProxySocketDevice::proxyServer | ( |  | ) | const

Retrieves the proxy server address.

Definition at line 80 of file khttpproxysocketdevice.cpp.

void KHttpProxySocketDevice::setProxyServer | ( | const KResolverEntry & | proxy | ) |

Sets the proxy server address.

Definition at line 85 of file khttpproxysocketdevice.cpp.

## Member Data Documentation

KResolverEntry KHttpProxySocketDevice::defaultProxy

static

This is the default proxy server to be used.

Applications may want to set this value so that calling setProxyServer is unnecessary.

Definition at line 117 of file khttpproxysocketdevice.h.

The documentation for this class was generated from the following files:

- khttpproxysocketdevice.h
- khttpproxysocketdevice.cpp

KDE Home | KDE Accessibility Home | Description of Access Keys